import argparse

import yaml

from trainer import Trainer


def main(args):
    with open(args.config) as f:
        config = yaml.load(f, Loader=yaml.FullLoader)

    for k, v in config.items():
        setattr(args, k, v)

    trainer = Trainer(args)
    if not args.extract:
        # train
        trainer.run()
    else:
        trainer.extract()


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='PyTorch Kinematics')
    parser.add_argument('--config', type=str, default='config.yaml')
    parser.add_argument('--launcher', default='pytorch', type=str)
    parser.add_argument('--load-iter',
                        # default=92000,
                        default=None,
                        type=int)
    parser.add_argument('--load-path',
                        # default='/home/ste/DiskE/CODE/whats-the-point-pytorch/checkpoints/ckpt_iter_92000.pth.tar',
                        default=None,
                        type=str)
    parser.add_argument('--resume', action='store_true',
                        # default=True
                        )
    parser.add_argument('--extract', action='store_true')
    parser.add_argument('--iou', type=float, default=None)
    parser.add_argument('--local_rank', type=int, default=0)
    parser.add_argument('--exp_path', type=str, default="./")
    args = parser.parse_args()

    main(args)
