import json

import numpy as np


def get_anno(cat, num):
    in_fn = '/home/ste/DiskG/DATASET/PartNet/train_val_test_split/{}.test.json'.format(
        cat)
    with open(in_fn, 'r') as fin:
        item_list = json.load(fin)
    data = []
    for each in item_list:
        data.append(each["anno_id"])
    return data[num]


def statis_data(cat):
    csum = np.zeros(10)
    vsum = 0
    in_fn = '/home/ste/DiskG/DATASET/PartNet/train_val_test_split/{}.train.json'.format(cat.split('-')[0])
    with open(in_fn, 'r') as fin:
        item_list = json.load(fin)
    print(len(item_list))
    voxels = np.load('/home/ste/DiskG/DATASET/PartNet/sem_seg_h5/' + cat + '/train_nor.npy').astype(
        np.long)
    unq = np.unique(voxels)
    print('training data:', len(voxels))
    vsum+=len(voxels)
    for each in range(1, len(unq)):
        has = np.sum(voxels == each, axis=(1, 2, 3))
        has = np.sum(has >= 1)
        print(each, has)
        csum[each] += has

    in_fn = '/home/ste/DiskG/DATASET/PartNet/train_val_test_split/{}.val.json'.format(cat.split('-')[0])
    with open(in_fn, 'r') as fin:
        item_list = json.load(fin)
    print(len(item_list))
    voxels = np.load('/home/ste/DiskG/DATASET/PartNet/sem_seg_h5/' + cat + '/val_nor.npy').astype(
        np.long)
    unq = np.unique(voxels)
    print('training data:', len(voxels))
    vsum+=len(voxels)
    for each in range(1, len(unq)):
        has = np.sum(voxels == each, axis=(1, 2, 3))
        has = np.sum(has >= 1)
        print(each, has)
        csum[each] += has

    in_fn = '/home/ste/DiskG/DATASET/PartNet/train_val_test_split/{}.test.json'.format(cat.split('-')[0])
    with open(in_fn, 'r') as fin:
        item_list = json.load(fin)
    print(len(item_list))
    voxels = np.load('/home/ste/DiskG/DATASET/PartNet/sem_seg_h5/' + cat + '/test_nor.npy').astype(
        np.long)
    unq = np.unique(voxels)
    print('training data:', len(voxels))
    vsum+=len(voxels)
    for each in range(1, len(unq)):
        has = np.sum(voxels == each, axis=(1, 2, 3))
        has = np.sum(has >= 1)
        print(each, has)
        csum[each] += has

    print(csum)
    print(vsum)


def cal_avg_height(path):
    data = np.load(path + 'train.npy')
    idx_list = np.unique(data)

    avg_ht = []
    for each in idx_list[1:]:
        avg_ht.append([np.mean(np.argwhere(data == each)[:, 2]), each])
    for i in range(len(avg_ht)):
        for j in range(i + 1, len(avg_ht)):
            if avg_ht[i][0] < avg_ht[j][0]:
                temp = avg_ht[i]
                avg_ht[i] = avg_ht[j]
                avg_ht[j] = temp
    print(avg_ht)

    # train_data
    data_trans = np.copy(data)
    for i in range(1, len(idx_list)):
        data_trans[data_trans == idx_list[i]] = avg_ht[i - 1][1]
        print('change idx {} to {}'.format(idx_list[i], avg_ht[i - 1][1]))
    np.save(path + 'train_nor.npy', data_trans)

    # val_data
    data = np.load(path + 'val.npy')
    data_trans = np.copy(data)
    for i in range(1, len(idx_list)):
        data_trans[data_trans == idx_list[i]] = avg_ht[i - 1][1]

    np.save(path + 'val_nor.npy', data_trans)

    # test_data
    data = np.load(path + 'test.npy')
    data_trans = np.copy(data)
    for i in range(1, len(idx_list)):
        data_trans[data_trans == idx_list[i]] = avg_ht[i - 1][1]
    np.save(path + 'test_nor.npy', data_trans)


if __name__ == '__main__':
    statis_data('Knife-1')
